## Script (Python) "check_transactions"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
# $Id: check_transactions.py 1620 2007-03-22 20:52:27Z joachim $
"""
payment callback
"""
import logging
logger = logging.getLogger('Skins.check_transactions')
from AccessControl import Unauthorized
import DateTime
if context.portal_membership.isAnonymousUser():
    return None

request = context.REQUEST
response = request.RESPONSE
students = context.portal_url.getPortalObject().campus.students
wftool = context.portal_workflow
mtool = context.portal_membership
member = mtool.getAuthenticatedMember()
member_id = str(member)
student_id = context.getStudentId()
online_transactions = context.online_payment_transactions
def rwrite(s):
    response.setHeader('Content-type','text/html; charset=ISO-8859-15')
    response.write("%s<br>\n" % s)
correct = 0
count = 0
for ot_brain in online_transactions():
    student_id = ot_brain.student_id
    if not students.hasObject(student_id):
        rwrite("%s not found" % student_id)
        continue
    student_obj = getattr(students,student_id)
    if not student_obj.hasObject('payments'):
        rwrite("%s payments-folder not found" % student_id)
        continue
    payments_folder = getattr(student_obj,'payments')
    payment_id = "p%s" % ot_brain.order_id[6:]
    if not payments_folder.hasObject(payment_id):
        rwrite("%s payment %s not found" % (student_id,payment_id))
        continue
    payment_doc = getattr(payments_folder,payment_id).getContent()
    response_code = ot_brain.response_code
    count +=1
    if payment_doc.resp_code != response_code:
        rwrite("%d:%d %s payment %s found bankresponse: %s != resp_code %s" % (
                                                                        count,correct,
                                                                        student_id,
                                                                        payment_id,
                                                                        response_code,
                                                                        payment_doc.resp_code
                                                                        ))
    elif payment_doc.resp_code == response_code:
        correct +=1
        rwrite("%d:%d %s payment %s found bankresponse: %s matches resp_code %s" % (
                                                                        count,correct,
                                                                        student_id,
                                                                        payment_id,
                                                                        response_code,
                                                                        payment_doc.resp_code
                                                                        ))
